// ATPluginFrame - ƶƮ ÷ ӿũ

#include "../StdAfx.h"
#include "ATPluginFrame.h"
#include "../ATPlugin.h"

#if _MSC_VER <= 1200 // 1200 = Visual C++ 6.0
#define memcpy_s(d,nd,s,ns) memcpy(d,s,ns)
#endif


CATPluginFrameApp::CATPluginFrameApp() : m_hAralWnd(NULL), m_pwszPluginOption(NULL), m_dwAralVersion(0)
{

	// ÷  ʱ 
	LPWSTR pwszPluginType;
#ifdef ATPLUGIN_ALGORITHM
	pwszPluginType = L"Algorithm";
#endif
#ifdef ATPLUGIN_TRANSLATOR
	pwszPluginType = L"Translator";
#endif
#ifdef ATPLUGIN_FILTER
	pwszPluginType = L"Filter";
#endif

	ZeroMemory(&m_sPluginInfo, sizeof(PLUGIN_INFO));
	m_sPluginInfo.cch = sizeof(PLUGIN_INFO);
	m_sPluginInfo.nIconID = IDI_PLUGINICON;
	lstrcpy(m_sPluginInfo.wszPluginType, pwszPluginType);
	lstrcpy(m_sPluginInfo.wszPluginName, L"ATPlugin");
	lstrcpy(m_sPluginInfo.wszDownloadUrl, L"http://");
}

BOOL CATPluginFrameApp::GetPluginInfo(PLUGIN_INFO * pPluginInfo)
{
	// ̰ ҷȴٴ  ÷ ƶƮ 0.3  ۵Ѵٴ ̴.
	m_dwAralVersion = MAKELONG(0003,0000);

	if (sizeof(PLUGIN_INFO) <= pPluginInfo->cch)
	{
		m_sPluginInfo.cch=pPluginInfo->cch; 
		memcpy(pPluginInfo, &m_sPluginInfo, m_sPluginInfo.cch);
		return TRUE;
	}
	return FALSE;
}

BOOL CATPluginFrameApp::OnObjectInit(TRANSLATION_OBJECT* pTransObj)
{
	BOOL bRetVal = FALSE;

#if defined(USE_ARALTRANS_0_3) && ( defined(ATPLUGIN_TRANSLATOR) || defined(ATPLUGIN_FILTER) )
	if(pTransObj)
	{
		//  ó  
		pTransObj->pPreTransBuf = malloc(TRANS_BUF_LEN);
		pTransObj->nPreTransBufLen = TRANS_BUF_LEN;
		ZeroMemory(pTransObj->pPreTransBuf, pTransObj->nPreTransBufLen);

		//  ó  
		pTransObj->pPostTransBuf = malloc(TRANS_BUF_LEN);
		pTransObj->nPostTransBufLen = TRANS_BUF_LEN;
		ZeroMemory(pTransObj->pPostTransBuf, pTransObj->nPostTransBufLen);

		//  ν 
		pTransObj->procTranslate = ::MainTranslateProcedure;
		bRetVal = TRUE;
	}
#endif // defined(USE_ARALTRANS_0_3) && ( defined(ATPLUGIN_TRANSLATOR) || defined(ATPLUGIN_FILTER) )
	return bRetVal;
}
BOOL CATPluginFrameApp::OnObjectClose(TRANSLATION_OBJECT* pTransObj)
{
	BOOL bRetVal = FALSE;

#if defined(USE_ARALTRANS_0_3) && ( defined(ATPLUGIN_TRANSLATOR) || defined(ATPLUGIN_FILTER) )
	if(pTransObj)
	{
		// ó  
		if(pTransObj->pPreTransBuf)
		{
			free(pTransObj->pPreTransBuf);
			pTransObj->pPreTransBuf = NULL;
		}
		pTransObj->nPreTransBufLen = 0;
		
		// ó  
		if(pTransObj->pPostTransBuf)
		{
			free(pTransObj->pPostTransBuf);
			pTransObj->pPostTransBuf = NULL;
		}
		pTransObj->nPostTransBufLen = 0;

		//  ν  
		pTransObj->procTranslate = NULL;
		bRetVal = TRUE;
	}

#endif // defined(USE_ARALTRANS_0_3) && ( defined(ATPLUGIN_TRANSLATOR) || defined(ATPLUGIN_FILTER) )
	return bRetVal;
}

BOOL CATPluginFrameApp::MainTranslateProcedure(TRANSLATION_OBJECT* pTransObj)
{

#if defined(USE_ARALTRANS_0_3) && ( defined(ATPLUGIN_TRANSLATOR) || defined(ATPLUGIN_FILTER) )

	TRESULT tResult = (TRESULT)(TR_DOALL | TR_STOP_OK), tResCurrent;

	try
	{

	//  ü ϴ Ȯ
	if(NULL == pTransObj) throw __LINE__;

	TRANSLATION_OBJECT* pPrevObj = pTransObj->pPrevObject;
	TRANSLATION_OBJECT* pNextObj = pTransObj->pNextObject;

	// ó ۰ ϴ Ȯ
	if(NULL == pTransObj->pPreTransBuf) throw __LINE__;
	ZeroMemory(pTransObj->pPreTransBuf, pTransObj->nPreTransBufLen);

	//  ü ϴ Ȯ
	if(NULL == pPrevObj) throw __LINE__;
	//  ü ó ۰ ϴ Ȯ
	if(NULL == pPrevObj->pPreTransBuf) throw __LINE__;
	//  ü ó  ũⰡ  Ȯ
	if(pTransObj->nPreTransBufLen < pPrevObj->nPreTransBufLen) throw __LINE__;

	//////////////////////////////////////////////////////////////////////////
	//
	// ó ۾
	//
#ifdef ATPLUGIN_FILTER
	//  ÷̶ ó ۾
	tResCurrent = PreTranslateEx(pTransObj);
	tResult = (TRESULT)((tResult | TR_STOP_OK) & tResCurrent);
#else
	//  ÷ ƴ϶ ܼ 
	memcpy_s(pTransObj->pPreTransBuf, pTransObj->nPreTransBufLen,
		pPrevObj->pPreTransBuf, pPrevObj->nPreTransBufLen);
#endif

	//
	// ó ۾ Ϸ
	//
	//////////////////////////////////////////////////////////////////////////

	//  ü ϴ Ȯ
	if(NULL == pNextObj) throw __LINE__;
	//  ü  ν ϴ Ȯ
	if(NULL == pNextObj->procTranslate) throw __LINE__;

	// ó ۰ ϴ Ȯ
	if(NULL == pTransObj->pPostTransBuf) throw __LINE__;
	ZeroMemory(pTransObj->pPostTransBuf, pTransObj->nPostTransBufLen);

	//  ü ó ۰ ϴ Ȯ
	if(NULL == pNextObj->pPostTransBuf) throw __LINE__;
	//  ü ó ۰  Ȯ
	if(pTransObj->nPostTransBufLen < pNextObj->nPostTransBufLen) throw __LINE__;

	//////////////////////////////////////////////////////////////////////////
	//
	//  ۾
	//
	// ü 
#ifdef ATPLUGIN_TRANSLATOR
	if (tResult & TR_TRANSONLY)
		tResCurrent = TranslateEx(pTransObj);
	tResult = (TRESULT)((tResult | TR_STOP_OK) & tResCurrent);
#endif
	// *  ü  ν 
	if (tResult & TR_NEXTONLY)
	{
		tResCurrent = NextTranslateEx(pTransObj);
		tResult = (TRESULT)((tResult | TR_STOP_OK) & tResCurrent);
	}
	else
		memcpy_s(pNextObj->pPostTransBuf, pNextObj->nPostTransBufLen,
			pTransObj->pPreTransBuf, pTransObj->nPreTransBufLen);


	//
	//  ۾ Ϸ
	//
	//////////////////////////////////////////////////////////////////////////


	//////////////////////////////////////////////////////////////////////////
	//
	// ó ۾
	//
#ifdef ATPLUGIN_FILTER
	//  ÷̶ ó ۾
	if (tResult & TR_POSTONLY)
	{
		tResCurrent = PostTranslateEx(pTransObj);
		tResult = (TRESULT)((tResult | TR_STOP_OK) & tResCurrent);
	}
#else
	//  ÷ ƴ϶ ܼ 
	if (tResult & TR_POSTONLY)
		memcpy_s(pTransObject->pPostTransBuf, pTransObject->nPostTransBufLen, 
			pNextObject->pPostTransBuf, pNextObject->nPostTransBufLen);

#endif

	//
	// ó ۾ Ϸ
	//
	//////////////////////////////////////////////////////////////////////////

	}
	catch (long e)
	{
		return FALSE;
	}
	if ( tResult == TR_STOPALL )
		return FALSE;

#endif // defined(USE_ARALTRANS_0_3) && ( defined(ATPLUGIN_TRANSLATOR) || defined(ATPLUGIN_FILTER) )
	return TRUE;
}

CATPluginFrameApp::TRESULT CATPluginFrameApp::PreTranslateEx(TRANSLATION_OBJECT *pTransObj)
{
#if defined(USE_ARALTRANS_0_3) && ( defined(ATPLUGIN_TRANSLATOR) || defined(ATPLUGIN_FILTER) )
	BOOL bRes = PreTranslate((LPCSTR)pTransObj->pPrevObject->pPreTransBuf, (LPSTR)pTransObj->pPreTransBuf, pTransObj->nPreTransBufLen);
	if (bRes == FALSE) return TR_STOPALL;
#endif // defined(USE_ARALTRANS_0_3) && ( defined(ATPLUGIN_TRANSLATOR) || defined(ATPLUGIN_FILTER) )
	return TR_DOALL;
}
CATPluginFrameApp::TRESULT CATPluginFrameApp::TranslateEx(TRANSLATION_OBJECT *pTransObj)
{
#if defined(USE_ARALTRANS_0_3) && ( defined(ATPLUGIN_TRANSLATOR) || defined(ATPLUGIN_FILTER) )
	LPSTR pszTransBuf = new char[pTransObj->nPreTransBufLen];
	BOOL bRes = Translate((LPCSTR)pTransObj->pPreTransBuf, pszTransBuf, pTransObj->nPreTransBufLen);
	if (bRes == FALSE) 
	{
		delete[] pszTransBuf;
		return TR_STOPALL;
	}
	memcpy(pTransObj->pPreTransBuf, pszTransBuf, pTransObj->nPreTransBufLen);
	delete[] pszTransBuf;

#endif // defined(USE_ARALTRANS_0_3) && ( defined(ATPLUGIN_TRANSLATOR) || defined(ATPLUGIN_FILTER) )
	return TR_DOALL;

}
CATPluginFrameApp::TRESULT CATPluginFrameApp::NextTranslateEx(TRANSLATION_OBJECT *pTransObj)
{
#if defined(USE_ARALTRANS_0_3) && ( defined(ATPLUGIN_TRANSLATOR) || defined(ATPLUGIN_FILTER) )
	BOOL bRes = pTransObj->pNextObject->procTranslate(pTransObj->pNextObject);
	if(FALSE == bRes) return TR_STOPALL;
#endif // defined(USE_ARALTRANS_0_3) && ( defined(ATPLUGIN_TRANSLATOR) || defined(ATPLUGIN_FILTER) )
	return TR_DOALL;
}
CATPluginFrameApp::TRESULT CATPluginFrameApp::PostTranslateEx(TRANSLATION_OBJECT *pTransObj)
{
#if defined(USE_ARALTRANS_0_3) && ( defined(ATPLUGIN_TRANSLATOR) || defined(ATPLUGIN_FILTER) )
	BOOL bRes = PostTranslate((LPCSTR)pTransObj->pNextObject->pPostTransBuf, (LPSTR)pTransObj->pPostTransBuf, pTransObj->nPostTransBufLen);
	if (bRes == FALSE) return TR_STOPALL;
#endif // defined(USE_ARALTRANS_0_3) && ( defined(ATPLUGIN_TRANSLATOR) || defined(ATPLUGIN_FILTER) )
	return TR_DOALL;
}
