//
// ATCApi - ƶƮ ̳  API  ϱ  
//
// ʿ  : tstring
//

#include "../../StdAfx.h"

#include "ATCApi.h"

#include "tstring.h"

CATCApi_LL g_cATCApi;

BOOL CATCApi_LL::Init()
{
	if (IsValid()) return TRUE;

	IATCApi_LL *pATCApi_LL;

	pATCApi_LL = new CATCApi_LL_0_2;

	if (pATCApi_LL->Init())
	{
		m_pATCApi_LL = pATCApi_LL;
		MessageBox(NULL, L"CATCApi = 0.2", L"TEST", MB_OK);
		return TRUE;
	}

	delete pATCApi_LL;
	pATCApi_LL = new CATCApi_LL_0_3;

	if (pATCApi_LL->Init())
	{
		m_pATCApi_LL = pATCApi_LL;
		MessageBox(NULL, L"CATCApi = 0.3", L"TEST", MB_OK);
		return TRUE;
	}
	delete pATCApi_LL;

	MessageBox(NULL, L"CATCApi Init Error", L"TEST", MB_OK);

	return FALSE;
}

BOOL CATCApi_LL_0_2::Init()
{
	using namespace NS_ARALTRANS_0_2;

	if (IsValid()) return TRUE;

	ZeroMemory(&m_cEntry, sizeof(m_cEntry));

	try 
	{
		// ATCTNR.DLL  ã´
		m_hContainer=GetModuleHandle(_T("ATCTNR.DLL"));
		if (!m_hContainer)	throw(_T("ATCTNR.DLL ã  ϴ."));

		//  Լ ͸ ´

		m_cEntry.pfnGetCurAlgorithm=(PROC_GetCurAlgorithm)GetProcAddress(m_hContainer, "GetCurAlgorithm");
		if (!m_cEntry.pfnGetCurAlgorithm) throw(_T("GetCurAlgorithm Լ ã  ϴ."));

		m_cEntry.pfnGetCurTranslator=(PROC_GetCurTranslator)GetProcAddress(m_hContainer, "GetCurTranslator");
		if (!m_cEntry.pfnGetCurTranslator) throw(_T("GetCurTranslator Լ ã  ϴ."));

		m_cEntry.pfnHookDllFunction=(PROC_HookDllFunction)GetProcAddress(m_hContainer, "HookDllFunction");
		if (!m_cEntry.pfnHookDllFunction) throw(_T("HookDllFunction Լ ã  ϴ."));

		m_cEntry.pfnUnhookDllFunction=(PROC_UnhookDllFunction)GetProcAddress(m_hContainer, "UnhookDllFunction");
		if (!m_cEntry.pfnUnhookDllFunction) throw(_T("UnhookDllFunction Լ ã  ϴ."));

		m_cEntry.pfnGetOrigDllFunction=(PROC_GetOrigDllFunction)GetProcAddress(m_hContainer, "GetOrigDllFunction");
		if (!m_cEntry.pfnGetOrigDllFunction) throw(_T("GetOrigDllFunction Լ ã  ϴ."));

		m_cEntry.pfnHookCodePoint=(PROC_HookCodePoint)GetProcAddress(m_hContainer, "HookCodePoint");
		if (!m_cEntry.pfnHookCodePoint) throw(_T("HookCodePoint Լ ã  ϴ."));

		m_cEntry.pfnUnhookCodePoint=(PROC_UnhookCodePoint)GetProcAddress(m_hContainer, "UnhookCodePoint");
		if (!m_cEntry.pfnUnhookCodePoint) throw(_T("UnhookCodePoint Լ ã  ϴ."));

		m_cEntry.pfnTranslateText=(PROC_TranslateText)GetProcAddress(m_hContainer, "TranslateText");
		if (!m_cEntry.pfnTranslateText) throw(_T("TranslateText Լ ã  ϴ."));

		m_cEntry.pfnIsAppLocaleLoaded=(PROC_IsAppLocaleLoaded)GetProcAddress(m_hContainer, "IsAppLocaleLoaded");
		if (!m_cEntry.pfnIsAppLocaleLoaded) throw(_T("IsAppLocaleLoaded Լ ã  ϴ."));

		m_cEntry.pfnEnableAppLocale=(PROC_EnableAppLocale)GetProcAddress(m_hContainer, "EnableAppLocale");
		if (!m_cEntry.pfnEnableAppLocale) throw(_T("EnableAppLocale Լ ã  ϴ."));

		// DefATContainer.h 0.2.20081012 Ŀ ߰ Լ
		//  ȣȯ  ã ϴ 밡ϵ Ѵ.

		try 
		{
			m_cEntry.pfnSuspendAllThread=(PROC_SuspendAllThread)GetProcAddress(m_hContainer, "SuspendAllThread");
			if (!m_cEntry.pfnSuspendAllThread) throw(_T("SuspendAllThread Լ ã  ϴ."));

			m_cEntry.pfnResumeAllThread=(PROC_ResumeAllThread)GetProcAddress(m_hContainer, "ResumeAllThread");
			if (!m_cEntry.pfnResumeAllThread) throw(_T("ResumeAllThread Լ ã  ϴ."));

			m_cEntry.pfnIsAllThreadSuspended=(PROC_IsAllThreadSuspended)GetProcAddress(m_hContainer, "IsAllThreadSuspended");
			if (!m_cEntry.pfnIsAllThreadSuspended) throw(_T("IsAllThreadSuspended Լ ã  ϴ."));
		}
		catch (TCHAR *szErrText)
		{
			OutputDebugString(szErrText);
			m_cEntry.pfnSuspendAllThread=NULL;
			m_cEntry.pfnResumeAllThread=NULL;
			m_cEntry.pfnIsAllThreadSuspended=NULL;
		}

	}
	catch(TCHAR *szErrText)
	{
		OutputDebugString(szErrText);
		m_hContainer=NULL;
		return FALSE;
	}
	return TRUE;
}

BOOL CATCApi_LL_0_2::HookWin32Api(LPCWSTR cszDllName, LPCWSTR cszFuncName, LPVOID pfnNew, int nPriority)
{
	char szDllName[MAX_PATH], szFuncName[MAX_PATH];

	Wide2Kor(cszDllName, szDllName, MAX_PATH);
	Wide2Kor(cszFuncName, szFuncName, MAX_PATH);
	return m_cEntry.pfnHookDllFunction(szDllName, szFuncName, pfnNew);

}

BOOL CATCApi_LL_0_2::UnhookWin32Api(LPCWSTR cszDllName, LPCWSTR cszFuncName, LPVOID pfnNew)
{
	char szDllName[MAX_PATH], szFuncName[MAX_PATH];

	Wide2Kor(cszDllName, szDllName, MAX_PATH);
	Wide2Kor(cszFuncName, szFuncName, MAX_PATH);
	return m_cEntry.pfnUnhookDllFunction(szDllName, szFuncName);;

}

BOOL CATCApi_LL_0_2::GetOrigWin32Api(LPCWSTR cszDllName, LPCWSTR cszFuncName, LPVOID pfnOld)
{
	char szDllName[MAX_PATH], szFuncName[MAX_PATH];

	Wide2Kor(cszDllName, szDllName, MAX_PATH);
	Wide2Kor(cszFuncName, szFuncName, MAX_PATH);
	pfnOld = m_cEntry.pfnGetOrigDllFunction(szDllName, szFuncName);

	if (!pfnOld) return FALSE;

	return TRUE;
}


BOOL CATCApi_LL_0_3::Init()
{
	using namespace NS_ARALTRANS_0_3;

	if (IsValid()) return TRUE;

	ZeroMemory(&m_cEntry, sizeof(m_cEntry));

	try 
	{
		// ATCTNR.DLL  ã´
		m_hContainer=GetModuleHandle(_T("ATCTNR3.DLL"));
		if (!m_hContainer)	throw(_T("ATCTNR3.DLL ã  ϴ."));

		//  Լ ͸ ´

		m_cEntry.procHookWin32Api=(PROC_HookWin32Api)GetProcAddress(m_hContainer, "HookWin32Api");
		if (!m_cEntry.procHookWin32Api) throw(_T("HookWin32Api Լ ã  ϴ."));

		m_cEntry.procUnhookWin32Api=(PROC_UnhookWin32Api)GetProcAddress(m_hContainer, "UnhookWin32Api");
		if (!m_cEntry.procUnhookWin32Api) throw(_T("UnhookWin32Api Լ ã  ϴ."));

		m_cEntry.procHookCodePoint=(PROC_HookCodePoint)GetProcAddress(m_hContainer, "HookCodePoint");
		if (!m_cEntry.procHookCodePoint) throw(_T("HookCodePoint Լ ã  ϴ."));

		m_cEntry.procUnhookCodePoint=(PROC_UnhookCodePoint)GetProcAddress(m_hContainer, "UnhookCodePoint");
		if (!m_cEntry.procUnhookCodePoint) throw(_T("UnhookCodePoint Լ ã  ϴ."));

		m_cEntry.procCreateTransCtx=(PROC_CreateTransCtx)GetProcAddress(m_hContainer, "CreateTransCtx");
		if (!m_cEntry.procCreateTransCtx) throw(_T("CreateTransCtx Լ ã  ϴ."));

		m_cEntry.procDeleteTransCtx=(PROC_DeleteTransCtx)GetProcAddress(m_hContainer, "DeleteTransCtx");
		if (!m_cEntry.procDeleteTransCtx) throw(_T("DeleteTransCtx Լ ã  ϴ."));

		m_cEntry.procTranslateUsingCtx=(PROC_TranslateUsingCtx)GetProcAddress(m_hContainer, "TranslateUsingCtx");
		if (!m_cEntry.procTranslateUsingCtx) throw(_T("TranslateUsingCtx Լ ã  ϴ."));

		m_cEntry.procIsAppLocaleLoaded=(PROC_IsAppLocaleLoaded)GetProcAddress(m_hContainer, "IsAppLocaleLoaded");
		if (!m_cEntry.procIsAppLocaleLoaded) throw(_T("IsAppLocaleLoaded Լ ã  ϴ."));

		m_cEntry.procSuspendAllThread=(PROC_SuspendAllThread)GetProcAddress(m_hContainer, "SuspendAllThread");
		if (!m_cEntry.procSuspendAllThread) throw(_T("SuspendAllThread Լ ã  ϴ."));

		m_cEntry.procResumeAllThread=(PROC_ResumeAllThread)GetProcAddress(m_hContainer, "ResumeAllThread");
		if (!m_cEntry.procResumeAllThread) throw(_T("ResumeAllThread Լ ã  ϴ."));

		m_cEntry.procIsAllThreadSuspended=(PROC_IsAllThreadSuspended)GetProcAddress(m_hContainer, "IsAllThreadSuspended");
		if (!m_cEntry.procIsAllThreadSuspended) throw(_T("IsAllThreadSuspended Լ ã  ϴ."));


	}
	catch(TCHAR *szErrText)
	{
		OutputDebugString(szErrText);
		m_hContainer=NULL;
		return FALSE;
	}
	return TRUE;
}

BOOL CATCApi_LL_0_3::GetOrigWin32Api(LPCWSTR cszDllName, LPCWSTR cszFuncName, LPVOID pfnOld)
{
	char szFuncName[MAX_PATH];
	
	HMODULE hModule = GetModuleHandle(cszDllName);
	if (!hModule) return FALSE;

	Wide2Kor(cszFuncName, szFuncName, MAX_PATH);

	pfnOld = (LPVOID) GetProcAddress(hModule, szFuncName);
	if (!pfnOld) return FALSE;

	return TRUE;
}


